VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   900
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   900
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtRoman 
      Height          =   285
      Left            =   840
      TabIndex        =   3
      Top             =   480
      Width           =   3735
   End
   Begin VB.TextBox txtArabic 
      Height          =   285
      Left            =   840
      TabIndex        =   2
      Top             =   120
      Width           =   3735
   End
   Begin VB.Label Label1 
      Caption         =   "Roman"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Arabic"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_IgnoreChanges As Boolean

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Const GWL_STYLE = (-16)
Private Const ES_UPPERCASE = &H8&
Private Const ES_NUMBER = &H2000&

' Add appropriate Roman digits to the result.
' The ten_letter, five_letter, and one_letter
' are the digits for 10, 5, and 1 at this
' power of ten. For example, 10/5/1 = X/V/I,
' 100/50/10 = C/L/X, etc.
Private Function AddRomanDigits(ByVal result As String, ByVal arabic_digit As Integer, ByVal ten_letter As String, ByVal five_letter As String, ByVal one_letter As String) As String
    Select Case arabic_digit
        Case 1 To 3
            result = result & String$(arabic_digit, one_letter)
        Case 4
            result = result & one_letter & five_letter
        Case 5
            result = result & five_letter
        Case 6 To 8
            result = result & five_letter & String$(arabic_digit - 5, one_letter)
        Case 9
            result = result & one_letter & ten_letter
    End Select

    AddRomanDigits = result
End Function
' Return the Roman numeral version of this number.
Private Function ArabicToRoman(ByVal arabic_string As String) As String
Dim arabic_number As Long
Dim digit As Long
Dim result As String

    If Len(arabic_string) = 0 Then Exit Function

    ' Pull out thousands.
    arabic_number = CInt(arabic_string)
    digit = arabic_number \ 1000
    arabic_number = arabic_number - digit * 1000
    result = result & String$(digit, "M")

    ' Pull out hundreds.
    digit = arabic_number \ 100
    arabic_number = arabic_number - digit * 100
    result = AddRomanDigits(result, digit, "M", "D", "C")

    ' Pull out tens.
    digit = arabic_number \ 10
    arabic_number = arabic_number - digit * 10
    result = AddRomanDigits(result, digit, "C", "L", "X")

    ' Pull out ones.
    digit = arabic_number
    result = AddRomanDigits(result, digit, "X", "V", "I")

    ArabicToRoman = result
End Function


' Return the Arabic version of this number.
Private Function RomanToArabic(ByVal roman As String) As Long
Dim i As Integer
Dim ch As String
Dim result As Long
Dim new_value As Long
Dim old_value As Long

    roman = UCase$(roman)
    old_value = 1000

    For i = 1 To Len(roman)
        ' See what the next character is worth.
        ch = Mid$(roman, i, 1)
        Select Case ch
            Case "I"
                new_value = 1
            Case "V"
                new_value = 5
            Case "X"
                new_value = 10
            Case "L"
                new_value = 50
            Case "C"
                new_value = 100
            Case "D"
                new_value = 500
            Case "M"
                new_value = 1000
        End Select

        ' See if this character is bigger
        ' than the previous one.
        If new_value > old_value Then
            ' The new value > the previous one.
            ' Add this value to the result
            ' and subtract the previous one twice.
            result = result + new_value - 2 * old_value
        Else
            ' The new value <= the previous one.
            ' Add it to the result.
            result = result + new_value
        End If

        old_value = new_value
    Next i

    RomanToArabic = result
End Function

Private Sub Form_Load()
    SetExtendedStyle txtArabic.hwnd, ES_NUMBER
    SetExtendedStyle txtRoman.hwnd, ES_UPPERCASE
End Sub
' Give the control the extended style.
Private Sub SetExtendedStyle(ByVal hwnd As Long, ByVal ex_style As Long)
Dim style As Long

    style = GetWindowLong(hwnd, GWL_STYLE)
    style = style Or ex_style
    SetWindowLong hwnd, GWL_STYLE, style
End Sub
Private Sub txtArabic_Change()
    If m_IgnoreChanges Then Exit Sub

    m_IgnoreChanges = True
    txtRoman.Text = ArabicToRoman(txtArabic.Text)
    m_IgnoreChanges = False
End Sub


Private Sub txtRoman_Change()
    If m_IgnoreChanges Then Exit Sub

    m_IgnoreChanges = True
    txtArabic.Text = Format$(RomanToArabic(txtRoman.Text))
    m_IgnoreChanges = False
End Sub

